diff -urN sourceold/scripts/dp88_customAI.h source/scripts/dp88_customAI.h
--- sourceold/scripts/dp88_customAI.h	2018-11-17 10:23:57.146600000 +1000
+++ source/scripts/dp88_customAI.h	2020-09-10 09:08:27.952893600 +1000
@@ -13,8 +13,24 @@
 
 #include "LoopedAnimationController.h"
 #include "ObserverImpClass.h"
+#include "ReferencerClass.h"
+
+class ActionParamsStruct;
+
+class Pathfind_Help_Implementer
+{
+public:
+	virtual ~Pathfind_Help_Implementer() {};
+	virtual bool Should_Ignore_Blocked_Checking(GameObject *obj) = 0;
+	virtual void Prepare_Getting_Around(GameObject *obj) = 0;
+	virtual void Stop_Getting_Around(GameObject *obj) = 0;
+	virtual void On_Unable_To_Get_Unstuck(GameObject *obj) = 0;
+	// Modify action params during getting unstuck to include target shooting, if any exist
+	virtual ActionParamsStruct Get_Param_Attack_Modifications(ActionParamsStruct params) = 0;
+};
 
 // Forward declaration
+class VehicleGameObj;
 class dp88_AI_Objective;
 class dp88_AI_ChargedTurret_AnimationObserver;
 
@@ -72,11 +88,16 @@
   int secondary_minRange, secondary_maxRange;
 
   // Current target state
-  int targetID;
+  //int targetID;
+  ReferencerClass m_target;
+  bool hasTarget;
   int targetLastSeen;
   float targetPriority;
   bool m_bTargetPrimaryFire;
 
+  // Brain speed
+  float thinkTime;
+
   // Other settings
   bool m_bAiEnabled;
   bool m_bCanDetectStealth;
@@ -85,6 +106,16 @@
   bool debug;
   FILE* debugFile;
 
+  // Target types
+  enum TargetType {
+	  SOLDIER = 0,
+	  LIGHT_VEHICLE,
+	  HEAVY_VEHICLE,
+	  FLYING,
+	  BUILDING,
+	  REPAIRABLE,
+	  UNKNOWN
+  };
 
 
 
@@ -126,11 +157,40 @@
   /* Utility functions for both priority calculations and AI scripts to utilise */
   virtual bool IsVehicleEmpty( VehicleGameObj* vobj );
   virtual bool IsVehicleAIEnabled( VehicleGameObj* vobj );
+
+  // "Global" decider about what a unit type is
+  static TargetType GetTargetType(GameObject* obj);
+};
+
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief danpaul88's Custom AI Heavy Vehicle Marker
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This is a dummy script with no functionality which can be attached to an object to indicate all of
+* my custom AI scripts should treat this as a heavy vehicle. Any vehicle without this script will be
+* considered to be a light vehicle.
+*/
+class dp88_AI_heavyVehicleMarker : public ScriptImpClass
+{
+	void Created(GameObject* obj);
 };
 
 // -------------------------------------------------------------------------------------------------
 
 /*!
+* \brief danpaul88's Custom AI Building Marker
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This is a dummy script with no functionality which can be attached to an object to indicate all of
+* my custom AI scripts should treat this as a building.
+*/
+class dp88_AI_Marker_Building : public ScriptImpClass {};
+
+// -------------------------------------------------------------------------------------------------
+
+/*!
 * \brief danpaul88's Custom AI Heavy Vehicle Marker
 * \author Daniel Paul (danpaul88@yahoo.co.uk)
 *
@@ -138,7 +198,25 @@
 * my custom AI scripts should treat this as a heavy vehicle. Any vehicle without this script will be
 * considered to be a light vehicle.
 */
-class dp88_AI_heavyVehicleMarker : public ScriptImpClass{};
+class dp88_AI_Marker_HeavyVehicle : public ScriptImpClass {};
+
+// -------------------------------------------------------------------------------------------------
+
+/*!
+* \brief danpaul88's Custom AI Repair Target Marker
+* \author Daniel Paul (danpaul88@yahoo.co.uk)
+*
+* This is a dummy script with no functionality which can be attached to an object to indicate all of
+* my custom AI scripts should treat this as a repair target.
+*/
+class dp88_AI_Marker_Repairable : public ScriptImpClass
+{
+public:
+    void Created(GameObject* obj);
+    float Get_Distance_From_Pathfind();
+protected:
+    float pathfindDistance;
+};
 
 // -------------------------------------------------------------------------------------------------
 
@@ -154,6 +232,7 @@
 public:
   // Game Events
   void Created(GameObject *obj);
+  void Detach(GameObject *obj);
   void Timer_Expired(GameObject *obj, int number);
   void Action_Complete(GameObject *obj, int action_id, ActionCompleteReason reason);
 
@@ -161,6 +240,12 @@
   virtual void Init(GameObject *obj);
   virtual void loadSettings(GameObject *obj, bool loadSecondaryFireSettings, bool loadBuildingTargetSettings);
 
+  virtual void Force_Clear_Current_Objective();
+  dp88_AI_Objective* Get_Current_Objective() { return m_pCurrentObjective; }
+
+  // used in combination with Force_Clear_Current_Objective() to invalidate references to objectives when they are deleted (prevents use-after-free bugs)
+  static DynamicVectorClass<dp88_AI_Unit*> ListOfAIUnits;
+
 protected:
   static const int ACTION_ID_MOVE_TO_OBJECTIVE  = 7850001;
   static const int ACTION_ID_ATTACK_TARGET      = 7850002;
@@ -169,7 +254,7 @@
   void ResetAllActions(GameObject* obj);
 
   // Go to the location of the current objective
-  virtual void GoToObjective(GameObject *obj);
+  virtual void GoToObjective(GameObject *obj, float speed = 1.0f);
 
   // Attack the specified target
   virtual void AttackTarget(GameObject *obj, GameObject *target);
@@ -746,9 +831,10 @@
 
   GameObject* GetGameObject();
 
-  unsigned char GetType()   { return m_type; }
+  unsigned int GetType()    { return m_type; }
   int GetTeam()             { return m_team; }
   int GetRange()            { return m_range; }
+  const char* GetDebugTag() { return m_debugTag; }
 
   /*! Get the priority of this objective for the specified AI unit */
   float GetPriority(GameObject* obj, float distance_modifier);
@@ -757,16 +843,26 @@
   * Finds the most suitable objective of a given type for the specified unit, based on the distance
   * to the objective and their distance modifier
   */
-  static dp88_AI_Objective* GetBestObjective ( GameObject* obj, unsigned char objective_type, float distance_modifier );
+  static dp88_AI_Objective* GetBestObjective ( GameObject* obj, unsigned int objective_type, float distance_modifier, DynamicVectorClass<int> ignoredObjectives );
+
+  /*!
+  * Counts the existing objectives of a given type for the specified team
+  */
+  static int CountObjectives( int team, unsigned int objective_type );
+
+  /*!
+  * Counts the existing valid objectives of a given type for the specified unit
+  */
+  static int CountUnitObjectives( int team, unsigned int objective_type, GameObject* obj, float distance_modifier );
 
   /*! Checks if the specified objective is still valid */
   static bool IsValidObjective ( dp88_AI_Objective* pObjective );
 
   /*! \name Objective types */
   /*! @{ */
-  const static unsigned char TYPE_OFFENSIVE = 1;
-  const static unsigned char TYPE_DEFENSIVE = 2;
-  const static unsigned char TYPE_ENGINEERING = 3;
+  const static unsigned int TYPE_OFFENSIVE = 1;
+  const static unsigned int TYPE_DEFENSIVE = 2;
+  const static unsigned int TYPE_ENGINEERING = 3;
   /*! @} */
 
 protected:
@@ -783,14 +879,15 @@
   /*! Get the unit type of the specified unit */
   unsigned char GetUnitType(GameObject* obj);
 
-  int m_objID;;
+  //int m_objID;;
 
   /*! \name Cached Script Parameters */
   /*! @{ */
-  unsigned char m_type;
+  unsigned int m_type;
   int m_priority[UNITTYPE_MAX + 1];
   int m_range;
   int m_team;
+  const char* m_debugTag;
   /*! @} */
 
   static DynamicVectorClass<dp88_AI_Objective *> Objectives;
diff -urN sourceold/scripts/dp88_custom_timer_defines.h source/scripts/dp88_custom_timer_defines.h
--- sourceold/scripts/dp88_custom_timer_defines.h	2018-11-17 10:23:57.147600000 +1000
+++ source/scripts/dp88_custom_timer_defines.h	2020-09-10 09:08:27.952893600 +1000
@@ -46,6 +46,7 @@
 #define CUSTOM_ROCKETEER_VEHICLEKILLED            (DP88_CUSTOM|MISC|0x03)             //!< Used by dp88_AR_Rocketeer to notify itself when the flight vehicle dies (via JFW_Death_Send_Custom)
 #define CUSTOM_VEHICLE_DEPLOY                     (DP88_CUSTOM|MISC|0x04)             //!< Used by deployable vehicle scripts to notify other scripts of a change in the deployment state, 0 = undeployed, 1 = deploying, 2 = deployed, 3 = undeploying
 #define CUSTOM_RADAR_JAM                          (DP88_CUSTOM|MISC|0x05)             //!< Used by new Radar Jammer scripts to switch radar off and on and also play jamming sounds, 0 = radar off, 1 = radar on
+#define CUSTOM_DEPLOY_STATE_CHANGED               (DP88_CUSTOM|MISC|0x07)             //!< Used by deployable scripts to notify other scripts of a change in the deployment state, 0 = undeployed, 1 = deployed
 
 #define TIMER_MISC_TICK                           (DP88_TIMER|MISC|0x01)              //!< Miscellaneous tick timer for generic use by scripts that implement on-tick events
 #define TIMER_RANDOMWEATHER                       (DP88_TIMER|MISC|0x02)              //!< Used by dp88_randomWeather to do a weather update
@@ -136,6 +137,7 @@
 //#define CUSTOM_TURRETAI_ANIMATIONCOMPLETE         (DP88_CUSTOM|AI|0x02)               //!< Sent from dp88_AI_ChargeTurret_Animation to dp88_AI_ChargeTurret
 #define CUSTOM_AI_DISABLEAI                       (DP88_CUSTOM|AI|0x03)               //!< Custom message that can be sent to a turret AI to disable it
 #define CUSTOM_AI_ENABLEAI                        (DP88_CUSTOM|AI|0x04)               //!< Custom message that can be sent to a turret AI to enable it
+#define CUSTOM_AI_RESET_ACTIONS                   (DP88_CUSTOM|AI|0x05)               //!< Custom message that can be sent to an AI to reset its current actions
 
 #define TIMER_AI_THINK                            (DP88_TIMER|AI|0x01)                //!< Fires every second to process AI actions such as checking target status
 #define TIMER_AI_CHARGE_PRERELOAD_COMPLETE        (DP88_TIMER|AI|0x02)                //!< Used by dp88_AI_ChargedTurret to indicate when pre-reloading is complete
@@ -171,6 +173,10 @@
 #define CUSTOM_PRISMTOWER_STOP_CHARGING				1144060002
 
 
+// Custom for changing bot count on a map
+#define CUSTOM_AI_CHANGE_BOTCOUNT					1144062001
+#define CUSTOM_AI_CHANGE_BOTCOUNTTEAM				1144062002
+
 #define TIMER_CLEG_PHASEDEATH					10055222
 #define TIMER_CLEG_CHECKDROPOBJ					10055223
 #define TIMER_CLEG_CHECKRELEASETARGET			10055224
diff -urN sourceold/scripts/engine_common.h source/scripts/engine_common.h
--- sourceold/scripts/engine_common.h	2018-11-17 10:23:57.154600000 +1000
+++ source/scripts/engine_common.h	2020-04-02 12:02:44.438361500 +1000
@@ -15,7 +15,7 @@
 // (float) is merely there to make sure that it uses the float overloads to send the version over network.
 // and to make sure we do not forget the f suffix on the version number.
 #define TT_VERSION_MAGIC '!TT!'
-#define TT_VERSION ((float)4.6f)
+#define TT_VERSION ((float)4.7f)
 
 #define SAFE_DELETE_ARRAY(p)	{ delete[] p; p = NULL; }
 #define SAFE_DELETE(p)			{ delete p; p = NULL; }
diff -urN sourceold/scripts/engine_dmg.cpp source/scripts/engine_dmg.cpp
--- sourceold/scripts/engine_dmg.cpp	2018-11-17 10:23:57.156600000 +1000
+++ source/scripts/engine_dmg.cpp	2020-09-10 09:08:27.953899600 +1000
@@ -161,6 +161,20 @@
 	Commands->Set_Health(obj,health);
 }
 
+void SCRIPTS_API Set_Max_Health_Without_Healing(GameObject *obj,float health)
+{
+	if (!obj)
+	{
+		return;
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
+	if (!o)
+	{
+		return;
+	}
+	o->Get_Defense_Object()->Set_Health_Max(health);
+}
+
 void SCRIPTS_API Set_Max_Shield_Strength(GameObject *obj,float shieldstrength)
 {
 	if (!obj)
@@ -176,6 +190,20 @@
 	Commands->Set_Shield_Strength(obj,shieldstrength);
 }
 
+void SCRIPTS_API Set_Max_Shield_Strength_Without_Healing(GameObject *obj,float shieldstrength)
+{
+	if (!obj)
+	{
+		return;
+	}
+	DamageableGameObj *o = obj->As_DamageableGameObj();
+	if (!o)
+	{
+		return;
+	}
+	o->Get_Defense_Object()->Set_Shield_Strength_Max(shieldstrength);
+}
+
 const char SCRIPTS_API *Get_Shield_Type(GameObject *obj)
 {
 	if (!obj)
@@ -226,6 +254,8 @@
 	{
 		return;
 	}
+	Vector3 TestPosition = Position;
+	TestPosition.Z = 0;
 	SLNode<VehicleGameObj> *x = GameObjManager::VehicleGameObjList.Head();
 	while (x)
 	{
@@ -233,10 +263,9 @@
 		if (obj) 
 		{
 			Vector3 ObjPosition = Commands->Get_Position(obj);
-			Vector3 TestPosition = Position;
+
 			ObjPosition.Z = 0;
-			TestPosition.Z = 0;
-			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance) && (Commands->Get_ID(obj) != Commands->Get_ID(Host)))
+			if ((Vector3::Distance_Squared(ObjPosition, TestPosition) <= Distance * Distance) && (Commands->Get_ID(obj) != Commands->Get_ID(Host)))
 			{
 				Commands->Apply_Damage(obj,Damage,Warhead,Damager);
 			}
@@ -251,6 +280,8 @@
 	{
 		return;
 	}
+	Vector3 TestPosition = Position;
+	TestPosition.Z = 0;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x) 
 	{
@@ -263,10 +294,8 @@
 		if (o2)
 		{
 			Vector3 ObjPosition = Commands->Get_Position(o2);
-			Vector3 TestPosition = Position;
 			ObjPosition.Z = 0;
-			TestPosition.Z = 0;
-			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance) && (Commands->Get_ID(o2) != Commands->Get_ID(Host)))
+			if ((Vector3::Distance_Squared(ObjPosition, TestPosition) <= Distance * Distance) && (Commands->Get_ID(o2) != Commands->Get_ID(Host)))
 			{
 				Commands->Apply_Damage(o2,Damage,Warhead,Damager);
 			}
@@ -289,7 +318,7 @@
 				{
 					Vector3 ObjPosition = Commands->Get_Position(o);
 					Vector3 TestPosition = Position;
-					if (Commands->Get_Distance(ObjPosition,TestPosition) <= Distance)
+					if (Vector3::Distance_Squared(ObjPosition, TestPosition) <= Distance * Distance)
 					{
 						Commands->Apply_Damage(o,Damage,Warhead,Damager);
 					}
@@ -316,9 +345,7 @@
 					Vector3 pos1 = Commands->Get_Position(o);
 					Vector3 pos2 = Location;
 
-					float Distance = Commands->Get_Distance(pos1,pos2);
-
-					if (Distance <= DamageRadius)
+					if (Vector3::Distance_Squared(pos1, pos2) <= DamageRadius * DamageRadius)
 					{
 						Commands->Apply_Damage(o,Damage,Warhead,Damager);
 					}
@@ -377,9 +404,7 @@
 					Vector3 pos1 = Commands->Get_Position(o);
 					Vector3 pos2 = Location;
 
-					float Distance = Commands->Get_Distance(pos1,pos2);
-
-					if (Distance <= DamageRadius)
+					if (Vector3::Distance_Squared(pos1, pos2) <= DamageRadius * DamageRadius)
 					{
 						float Max_Health = Commands->Get_Max_Health(o);
 						float Damage = Max_Health*Percentage;
@@ -409,8 +434,7 @@
 					{
 						Vector3 pos1 = Commands->Get_Position(o);
 						Vector3 pos2 = Location;
-						float Distance = Commands->Get_Distance(pos1,pos2);
-						if (Distance <= DamageRadius)
+						if (Vector3::Distance_Squared(pos1, pos2) <= DamageRadius * DamageRadius)
 						{
 							Commands->Apply_Damage(o,Damage,Warhead,Damager);
 						}
@@ -472,8 +496,7 @@
 					{
 						Vector3 pos1 = Commands->Get_Position(o);
 						Vector3 pos2 = Location;
-						float Distance = Commands->Get_Distance(pos1,pos2);
-						if (Distance <= DamageRadius)
+						if (Vector3::Distance_Squared(pos1, pos2) <= DamageRadius * DamageRadius)
 						{
 							float Max_Health = Commands->Get_Max_Health(o);
 							float Damage = Max_Health*Percentage;
@@ -517,8 +540,8 @@
 				{
 					Vector3 pos1 = Commands->Get_Position(o);
 					Vector3 pos2 = Location;
-					float Distance = Commands->Get_Distance(pos1,pos2);
-					if (Distance <= DamageRadius)
+					float Distance = Vector3::Distance_Squared(pos1, pos2);
+					if (Distance <= DamageRadius * DamageRadius)
 					{
 						float Max_Health = Commands->Get_Max_Health(o);
 						float Max_Shield = Commands->Get_Max_Shield_Strength(o);
@@ -576,8 +599,8 @@
 				{
 					Vector3 pos1 = Commands->Get_Position(o);
 					Vector3 pos2 = Location;
-					float Distance = Commands->Get_Distance(pos1,pos2);
-					if (Distance <= Radius)
+					float Distance = Vector3::Distance_Squared(pos1, pos2);
+					if (Distance <= Radius * Radius)
 					{
 						Commands->Set_Health(o,(amount+Health));
 					}
@@ -719,8 +742,8 @@
 				{
 					Vector3 pos1 = Commands->Get_Position(o);
 					Vector3 pos2 = Location;
-					float Distance = Commands->Get_Distance(pos1,pos2);
-					if (Distance <= DamageRadius)
+					float Distance = Vector3::Distance_Squared(pos1, pos2);
+					if (Distance <= DamageRadius * DamageRadius)
 					{
 						float Max_Health = Commands->Get_Max_Health(o);
 						float Max_Shield = Commands->Get_Max_Shield_Strength(o);
@@ -767,8 +790,8 @@
 					{
 						Vector3 pos1 = Commands->Get_Position(o);
 						Vector3 pos2 = Location;
-						float Distance = Commands->Get_Distance(pos1, pos2);
-						if (Distance <= DamageRadius)
+						float Distance = Vector3::Distance_Squared(pos1, pos2);
+						if (Distance <= DamageRadius * DamageRadius)
 						{
 							float Max_Health = Commands->Get_Max_Health(o);
 							float Max_Shield = Commands->Get_Max_Shield_Strength(o);
diff -urN sourceold/scripts/engine_dmg.h source/scripts/engine_dmg.h
--- sourceold/scripts/engine_dmg.h	2016-10-31 07:17:12.471013500 +1000
+++ source/scripts/engine_dmg.h	2020-03-30 20:42:37.433301100 +1000
@@ -15,7 +15,9 @@
 void SCRIPTS_API Repair_All_Buildings_By_Team(int Team,int ConstructionYardID,float Health); //repairs all buildings for the team except the passed in ConstructionYardID,0 = Nod,1 = GDI
 void SCRIPTS_API Repair_All_Static_Vehicles_By_Team(int Team,int type); //sends a custom to all vechicles of the team with the DecorationPhys physics type (i.e. all base defense vechicles etc),0 = Nod,1 = GDI,Message is the message to send. Use with JFW_Repair_On_Custom on the vechicles you want repaired to do the actual repairing
 void SCRIPTS_API Set_Max_Health(GameObject *obj,float health); //set the max health of obj
+void SCRIPTS_API Set_Max_Health_Without_Healing(GameObject *obj,float health); //set the max health of obj without setting the actual health to maximum
 void SCRIPTS_API Set_Max_Shield_Strength(GameObject *obj,float shieldstrength); //set the max shield strength of obj
+void SCRIPTS_API Set_Max_Shield_Strength_Without_Healing(GameObject *obj,float shieldstrength); //set the max shield strength of obj without setting the actual health to maximum
 const char SCRIPTS_API *Get_Shield_Type(GameObject *obj); //gets the shield type of obj
 const char SCRIPTS_API *Get_Skin(GameObject *obj); //gets the skin type of obj
 void SCRIPTS_API Set_Skin(GameObject *obj,const char *Skintype); //sets the skin type of obj
diff -urN sourceold/scripts/engine_io.cpp source/scripts/engine_io.cpp
--- sourceold/scripts/engine_io.cpp	2018-11-17 10:23:57.160600000 +1000
+++ source/scripts/engine_io.cpp	2020-09-10 09:08:27.953899600 +1000
@@ -565,6 +565,26 @@
 	strtrim(result);
 	return (int)strlen(result);
 }
+int INIClass::Get_String_Advanced(char const *section,char const *entry,char const *defaultvalue,char *result,int size,bool updateIfNotFound) const
+{
+	if (!result || size <= 1 || !section || !entry)
+		return 0;
+	INIEntry *Entry = Find_Entry(section,entry);
+	const char *value = defaultvalue;
+	if (Entry && Entry->Value)
+		value = Entry->Value;
+	if ((!Entry || !Entry->Value) && !updateIfNotFound) 
+		return 0;
+	if (!value)
+	{
+		result[0] = 0;
+		return 0;
+	}
+	strncpy(result, value, size);
+	result[size - 1] = 0;
+	strtrim(result);
+	return (int)strlen(result);
+}
 int INIClass::Entry_Count(char const *section) const
 {
 	INISection *Section = Find_Section(section);
diff -urN sourceold/scripts/engine_io.h source/scripts/engine_io.h
--- sourceold/scripts/engine_io.h	2018-11-17 10:23:57.161600000 +1000
+++ source/scripts/engine_io.h	2020-09-10 09:08:27.954910800 +1000
@@ -132,6 +132,7 @@
 	float Get_Float(char const *section,char const *entry,float defaultvalue) const;
 	bool Get_Bool(char const *section,char const *entry,bool defaultvalue) const;
 	int Get_String(char const *section,char const *entry,char const *defaultvalue,char *result,int size) const;
+	int Get_String_Advanced(char const *section,char const *entry,char const *defaultvalue,char *result,int size,bool writeIfNotFound) const;
 	StringClass &Get_String(StringClass &str, const char* section, const char* entry, const char* default = 0) const;
 	WideStringClass &Get_Wide_String(WideStringClass &,char  const*,char  const*,wchar_t  const*) const;
 	bool Put_Wide_String(const char* section, const char* entry, const wchar_t* string);
diff -urN sourceold/scripts/engine_obj.cpp source/scripts/engine_obj.cpp
--- sourceold/scripts/engine_obj.cpp	2018-11-17 10:23:57.163600000 +1000
+++ source/scripts/engine_obj.cpp	2020-09-10 09:08:27.954910800 +1000
@@ -403,7 +403,7 @@
 
 GameObject SCRIPTS_API *Find_Closest_Non_Building_Object_By_Team(int Team,Vector3 position)
 {
-	float closestdist = FLT_MAX;
+	float closestdist_sq = FLT_MAX;
 	GameObject *closest = 0;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
@@ -419,10 +419,10 @@
 			if ((Get_Object_Type(o2) == Team) && !o2->As_BuildingGameObj())
 			{
 				Vector3 pos = Commands->Get_Position(o2);
-				float dist = Commands->Get_Distance(pos,position);
-				if (dist < closestdist)
+				float dist_sq = Vector3::Distance_Squared(pos, position);
+				if (dist_sq < closestdist_sq)
 				{
-					closestdist = dist;
+					closestdist_sq = dist_sq;
 					closest = o2;
 				}
 			}
@@ -434,7 +434,7 @@
 
 GameObject SCRIPTS_API *Find_Closest_Preset_By_Team(int Team,const Vector3 &pos,const char *Preset)
 {
-	float closestdist = 9999.0f;
+	float closestdist_sq = FLT_MAX;
 	GameObject *closest = 0;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
@@ -449,10 +449,10 @@
 		{
 			if ((Get_Object_Type(o2) == Team || Team == 2) && !_stricmp(Commands->Get_Preset_Name(o2),Preset))
 			{
-				float dist = Commands->Get_Distance(Commands->Get_Position(o2),pos);
-				if (dist < closestdist)
+				float dist_sq = Vector3::Distance_Squared(Commands->Get_Position(o2), pos);
+				if (dist_sq < closestdist_sq)
 				{
-					closestdist = dist;
+					closestdist_sq = dist_sq;
 					closest = o2;
 				}
 			}
@@ -558,6 +558,7 @@
 GameObject SCRIPTS_API *Find_Nearest_Preset(Vector3 position, const char *preset)
 {
 	GameObject *object = 0;
+	float min_dist_sq = FLT_MAX;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x)
 	{
@@ -571,18 +572,13 @@
 		{
 			if (!_stricmp(Commands->Get_Preset_Name(o2),preset))
 			{
-				if (object)
-				{
-					Vector3 obj_pos = Commands->Get_Position(object);
-					Vector3 o_pos = Commands->Get_Position(o2);
-					if (Commands->Get_Distance(position, o_pos) < Commands->Get_Distance(position, obj_pos))
-					{
-						object = o2;
-					}
-				}
-				else
+				Vector3 pos;
+				o2->Get_Position(&pos);
+				float dist_sq = Vector3::Distance_Squared(position, pos);
+				if (dist_sq < min_dist_sq)
 				{
 					object = o2;
+					min_dist_sq = dist_sq;
 				}
 			}
 		}
@@ -689,6 +685,8 @@
 	{
 		return;
 	}
+	Vector3 TestPosition = Position;
+	TestPosition.Z = 0;
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
 	while (x) 
 	{
@@ -701,10 +699,8 @@
 		if (o2)
 		{
 			Vector3 ObjPosition = Commands->Get_Position(o2);
-			Vector3 TestPosition = Position;
 			ObjPosition.Z = 0;
-			TestPosition.Z = 0;
-			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance))
+			if (Vector3::Distance_Squared(ObjPosition, TestPosition) <= Distance * Distance)
 			{
 				if ((Get_Object_Type(o2) == team) || (team == 2))
 				{
@@ -787,7 +783,7 @@
 				Vector3 pos = Commands->Get_Position(o2);
 				pos.Z = 0;
 				location.Z = 0;
-				if (Commands->Get_Distance(pos,location) <= range)
+				if (Vector3::Distance_Squared(pos, location) <= range * range)
 				{
 					if (o2->As_VehicleGameObj() && !empty)
 					{
@@ -909,7 +905,7 @@
 
 GameObject SCRIPTS_API *Get_Closest_Armed_Object_To_Object( GameObject* obj, int team )
 {
-	float closestdist = FLT_MAX;
+	float closestdist_sq = FLT_MAX;
 	GameObject *closest = 0;
 	Vector3 position = Commands->Get_Position(obj);
 	SLNode<BaseGameObj> *x = GameObjManager::GameObjList.Head();
@@ -926,10 +922,10 @@
 			if ((team == 2 || Get_Object_Type(o2) == team) && o2->As_PhysicalGameObj() && o2->As_PhysicalGameObj()->As_ArmedGameObj())
 			{
 				Vector3 pos = Commands->Get_Position(o2);
-				float dist = Commands->Get_Distance(pos,position);
-				if (dist < closestdist)
+				float dist_sq = Vector3::Distance_Squared(pos, position);
+				if (dist_sq < closestdist_sq)
 				{
-					closestdist = dist;
+					closestdist_sq = dist_sq;
 					closest = o2;
 				}
 			}
diff -urN sourceold/scripts/engine_obj2.cpp source/scripts/engine_obj2.cpp
--- sourceold/scripts/engine_obj2.cpp	2018-11-17 10:23:57.165600000 +1000
+++ source/scripts/engine_obj2.cpp	2020-09-10 09:08:27.955908400 +1000
@@ -33,14 +33,14 @@
 AT2(0x006C6420,0x006C5CC0);
 ScriptZoneGameObj *ScriptZoneGameObj::Find_Closest_Zone(Vector3 &Location,ZoneConstants::ZoneType Type)
 {
-	float closest = 999999;
+	float closest = FLT_MAX;
 	ScriptZoneGameObj *closestzone = 0;
 	for (SLNode<ScriptZoneGameObj>* node = GameObjManager::ScriptZoneGameObjList.Head(); node; node = node->Next())
 	{
 		ScriptZoneGameObj *zone = node->Data();
 		if (zone->Get_Definition().Get_Type() == Type)
 		{
-			float distance = Vector3::Distance(zone->Get_Bounding_Box().Center,Location);
+			float distance = Vector3::Distance_Squared(zone->Get_Bounding_Box().Center,Location);
 			if (distance < closest)
 			{
 				closest = distance;
diff -urN sourceold/scripts/engine_phys.cpp source/scripts/engine_phys.cpp
--- sourceold/scripts/engine_phys.cpp	2018-11-17 10:23:57.167600000 +1000
+++ source/scripts/engine_phys.cpp	2020-09-10 09:08:27.956842600 +1000
@@ -150,15 +150,15 @@
 
 void SCRIPTS_API Create_Effect_All_Stealthed_Objects_Area(const Vector3 &Position,float Distance,const char *object,const Vector3 &offset,int team)
 {
+	Vector3 TestPosition = Position;
+	TestPosition.Z = 0;
 	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
 	while (x) 
 	{
 		SmartGameObj *obj = x->Data();
 		Vector3 ObjPosition = Commands->Get_Position(obj);
-		Vector3 TestPosition = Position;
 		ObjPosition.Z = 0;
-		TestPosition.Z = 0;
-		if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance))
+		if ((Vector3::Distance_Squared(ObjPosition,TestPosition) <= Distance * Distance))
 		{
 			if ((Get_Object_Type(obj) == team) || (team == 2))
 			{
diff -urN sourceold/scripts/engine_player.cpp source/scripts/engine_player.cpp
--- sourceold/scripts/engine_player.cpp	2018-11-17 10:23:57.169600000 +1000
+++ source/scripts/engine_player.cpp	2020-03-28 21:10:59.023831800 +1000
@@ -76,10 +76,14 @@
 	{
 		return newstr("None");
 	}
-	if (!((cPlayer *)o->Get_Player_Data()))
+	if (!((cPlayer *)o->Get_Player_Data()) && o->Get_Bot_Tag().Is_Empty())
 	{
 		return newstr("None");
 	}
+	if (!o->Get_Bot_Tag().Is_Empty())
+	{
+		return WideCharToChar(o->Get_Bot_Tag());
+	}
 	return WideCharToChar(((cPlayer *)o->Get_Player_Data())->Get_Name());
 }
 
@@ -504,10 +508,14 @@
 	{
 		return L"None";
 	}
-	if (!((cPlayer *)o->Get_Player_Data()))
+	if (!((cPlayer *)o->Get_Player_Data()) && o->Get_Bot_Tag().Is_Empty())
 	{
 		return L"None";
 	}
+	if (!o->Get_Bot_Tag().Is_Empty())
+	{
+		return o->Get_Bot_Tag().Peek_Buffer();
+	}
 	return ((cPlayer *)o->Get_Player_Data())->Get_Name().Peek_Buffer();
 }
 
diff -urN sourceold/scripts/engine_pt.cpp source/scripts/engine_pt.cpp
--- sourceold/scripts/engine_pt.cpp	2018-11-17 10:23:57.171600000 +1000
+++ source/scripts/engine_pt.cpp	2020-09-10 09:08:27.956842600 +1000
@@ -15,10 +15,9 @@
 #include "engine_def.h"
 #include "engine_obj2.h"
 
-unsigned int SCRIPTS_API Get_Team_Cost(const char *preset,unsigned int team)
+unsigned int SCRIPTS_API Get_Team_Cost(int def_id,unsigned int team)
 {
-	int ID = Get_Definition_ID(preset);
-	if (TeamPurchaseSettingsDefClass::Get_Definition((TeamPurchaseSettingsDefClass::TEAM)PTTEAM(team))->Get_Beacon_Definition() == ID)
+	if (TeamPurchaseSettingsDefClass::Get_Definition((TeamPurchaseSettingsDefClass::TEAM)PTTEAM(team))->Get_Beacon_Definition() == def_id)
 	{
 		return TeamPurchaseSettingsDefClass::Get_Definition((TeamPurchaseSettingsDefClass::TEAM)PTTEAM(team))->Get_Beacon_Cost();
 	}
@@ -29,7 +28,7 @@
 		{
 			for (unsigned int j = 0;j < 10;j++)
 			{
-				if ((p->Get_Definition(j) == ID) || (p->Get_Alt_Definition(j,0) == ID) || (p->Get_Alt_Definition(j,1) == ID) || (p->Get_Alt_Definition(j,2) == ID))
+				if ((p->Get_Definition(j) == def_id) || (p->Get_Alt_Definition(j,0) == def_id) || (p->Get_Alt_Definition(j,1) == def_id) || (p->Get_Alt_Definition(j,2) == def_id))
 				{
 					return p->Get_Cost(j);
 				}
@@ -39,16 +38,26 @@
 	return 0;
 }
 
-unsigned int SCRIPTS_API Get_Cost(const char *preset)
+unsigned int SCRIPTS_API Get_Team_Cost(const char *preset,unsigned int team)
+{
+	return Get_Team_Cost(Get_Definition_ID(preset), team);
+}
+
+unsigned int SCRIPTS_API Get_Cost(int def_id)
 {
-	unsigned int cost = Get_Team_Cost(preset,0);
+	unsigned int cost = Get_Team_Cost(def_id,0);
 	if (!cost)
 	{
-		cost = Get_Team_Cost(preset,1);
+		cost = Get_Team_Cost(def_id,1);
 	}
 	return cost;
 }
 
+unsigned int SCRIPTS_API Get_Cost(const char *preset)
+{
+	return Get_Cost(Get_Definition_ID(preset));
+}
+
 void SCRIPTS_API Disable_Preset_By_Name(unsigned int Team,const char *Name, bool enable)
 {
 	int ID = Get_Definition_ID(Name);
diff -urN sourceold/scripts/engine_pt.h source/scripts/engine_pt.h
--- sourceold/scripts/engine_pt.h	2018-11-17 10:23:57.172600000 +1000
+++ source/scripts/engine_pt.h	2020-09-10 09:08:27.957841300 +1000
@@ -14,7 +14,9 @@
 #include "BuildingGameObjDef.h"
 using namespace BuildingConstants;
 unsigned int SCRIPTS_API Get_Team_Cost(const char *preset,unsigned int team); //Get the cost of a preset for a given team. Returns zero if the preset is not found in any of the purchase terminal data or if it is one of the free units.
+unsigned int SCRIPTS_API Get_Team_Cost(int def_id,unsigned int team); //Get the cost of a preset for a given team. Returns zero if the preset is not found in any of the purchase terminal data or if it is one of the free units.
 unsigned int SCRIPTS_API Get_Cost(const char *preset); //Get the cost of a preset. Returns zero if the preset is not found in any of the purchase terminal data or if it is one of the free units.
+unsigned int SCRIPTS_API Get_Cost(int def_id); //Get the cost of a preset. Returns zero if the preset is not found in any of the purchase terminal data or if it is one of the free units.
 void SCRIPTS_API Disable_Preset_By_Name(unsigned int Team,const char *Name, bool enable); //Disable a preset by name
 void SCRIPTS_API Hide_Preset_By_Name(unsigned int Team,const char *Name, bool enable); //Hides a preset by name
 void SCRIPTS_API Busy_Preset_By_Name(unsigned int Team,const char *Name, bool enable); //Marks a preset as busy by name
